import time
import threading

def _do_every_thread(f, fps, *args):
    count = 0
    period = 1.0/fps
    startTime = time.time()
    while True:
        f(args)
        now = time.time()
        # print(now, startTime + count*period)
        count = count + 1
        elapsed = now - startTime
        sleepDuration = period - (elapsed%period)
        if elapsed > 2056 :
            startTime = now
        time.sleep(sleepDuration)

def do_every(f, fps=30, *args):
    args2 = [f,fps]
    args2.extend(args)
    t = threading.Thread(target=_do_every_thread, args=args2)
    t.daemon = True
    t.start()
    return t

if __name__ == '__main__':
    foo = 123
    def printThing(argument):
        print(time.time(), argument)

    foo = do_every(printThing, 15, foo,1234)
    print(foo)
    print('doing other things...')
    time.sleep(4)

